using System;
using System.Runtime.InteropServices;

namespace RawSockets
{
    //  ip 
    [StructLayout(LayoutKind.Explicit)]
    public struct IpHeader
    {
        [FieldOffset(0)] public byte ip_verlen; // IP version and IP Header length( ip,  4    ,  4 )
        [FieldOffset(1)] public byte ip_tos; // Type of service( ,  rfc 791)
        [FieldOffset(2)] public short ip_totallength; // total length of the packet(  )
        [FieldOffset(4)] public short ip_id; // unique identifier( )
        [FieldOffset(6)] public short ip_offset; // flags and offset(,  3 ; 13  ,   64 )
        [FieldOffset(8)] public byte ip_ttl; // Time To Live( )
        [FieldOffset(9)] public byte ip_protocol; // protocol (TCP, UDP etc)( ,     rfc 791)
        [FieldOffset(10)] public short ip_checksum; //IP Header checksum( )
        [FieldOffset(12)] public uint ip_srcaddr; //Source address( )
        [FieldOffset(16)] public uint ip_destaddr;//Destination Address( )
    }
    
    /// <summary>
    ///       
    /// </summary>
    /// <remarks>
    /// ip -      , header - ip , _other_header -  
    ///  ip(TCP, UDP and etc,   )
    /// </remarks>
    [Serializable]
    public delegate void CapturePacket(string _ip, IpHeader _header, object _other_header);

    // TCP ,  RFC 793
    [StructLayout(LayoutKind.Explicit)]
    public  struct TCPHeader
            {
                [FieldOffset(0)] public short	SourcePort;
                [FieldOffset(2)] public short	DestinationPort;
                [FieldOffset(4)] public uint	SequenceNumber;
                [FieldOffset(8)] public uint	AcknowledgeNumber;
                [FieldOffset(12)] public byte	DataOffset;		
                [FieldOffset(13)] public byte 	Flags;
                [FieldOffset(14)] public short	Windows;
                [FieldOffset(16)] public short	Checksum;
                [FieldOffset(18)] public short	UrgentPointer;
            };

    /// <summary>
    ///   UDP 
    /// </summary>
    [StructLayout(LayoutKind.Explicit)]
    public  struct UDPHeader
            {
               [FieldOffset(0)] public short	SourcePort;
               [FieldOffset(2)] public short	DestinationPort;
               [FieldOffset(4)] public short	Length;
               [FieldOffset(6)] public short	Checksum;
            };


}